//  main: main.less, out: ../style.css


/* ====================================================================================================================================
UTILITY CLASSES
======================================================================================================================================*/
// cover image
.u-cover-image {
    position: absolute;
    height: 100%;
    width: 100%;
    bottom: 0;
    top: 0;
    left: 0;
    z-index: 0 !important;

    img {
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        width: 100%;
        height: 100%;
        object-fit: cover;
    }
}

// transform
.u-transform (@handler) {
  transform        : @handler;
  -webkit-transform: @handler;
}

.u-transform-origin (@origin) {
  transform-origin: @origin;
  -webkit-transform-origin: @origin;
}

// border radius
.u-border-radius (@radius) {
  border-radius        : @radius;
  -webkit-border-radius: @radius;
}

// shadow
.u-shadow (@shadow) {
    box-shadow        : @shadow;
    -webkit-box-shadow: @shadow;
}


// border-box
.u-border-box {
  box-sizing        : border-box;
  -moz-box-sizing   : border-box;
  -webkit-box-sizing: border-box;
}

.u-list {
    position       : relative;
    list-style-type: none;

    &--custom {
        margin-left: 1.5rem;

        &:after {
            content            : "";
            display            : block;
            position           : absolute;
            width              : 10px;
            height             : 10px;
            top                : 0;
            left               : -1.5rem;
            background         : url('');
            background-position: center;
            background-repeat  : no-repeat;
            background-size    : cover;
            background-color   : @color__black;
        }
    }
}

.u-noselect {
    -webkit-touch-callout: none; /* iOS Safari */
    -webkit-user-select: none; /* Safari */
     -khtml-user-select: none; /* Konqueror HTML */
       -moz-user-select: none; /* Firefox */
        -ms-user-select: none; /* Internet Explorer/Edge */
            user-select: none; 
}

// linear gradient
.u-linear-gradient (@angle, @start, @end) {
    background: @start;
    background: -webkit-linear-gradient(@angle, @start, @end);
    background: -o-linear-gradient(@angle, @start, @end);
    background: -moz-linear-gradient(@angle, @start, @end);
    background: linear-gradient(@angle, @start, @end);
}

// placeholder color
.u-placeholderColor(@color) {
  &::-webkit-input-placeholder { /* Safari, Chrome and Opera */
      color: @color;
      opacity: 1;
  }

  &:-moz-placeholder { /* Firefox 18- */
      color: @color;
      opacity: 1;
  }

  &::-moz-placeholder { /* Firefox 19+ */
      color: @color;
      opacity: 1;
  }

  &:-ms-input-placeholder { /* IE 10+ */
      color: @color;
      opacity: 1;
  }

  &::-ms-input-placeholder { /* Edge */
      color: @color;
      opacity: 1;
  }

  &:placeholder-shown { /* Standard one last! */
      color: @color;
      opacity: 1;
  }
}

// text align centered
.u-center {
    text-align: center;
}

// custom list style
.u-list-style {
    ul {
		list-style: none;
		margin: 0;
		padding-left: @size__s;
	}
	
	li {
		position: relative;
		margin: 10px 0;
		&:after {
			position: absolute;
			content: '';
			display: block;
			height: 6px;
			width: 6px;
			background-color: @color__secondary;
			left: -@size__s;
			top: .6em;
			.u-border-radius(100%);
		}
	}
}

/*------------------------------------*\
  #FLEXBOX
\*------------------------------------*/

.u-flex-display(@display: flex) {
    display: ~"-webkit-@{display}";
    display: ~"-ms-@{display}box"; // IE10 uses -ms-flexbox
    display: ~"-ms-@{display}"; // IE11
    display: @display;
}

.u-flex(@columns: initial) {
    -webkit-flex: @columns;
    -ms-flex: @columns;
    flex: @columns;
}

.u-flex-direction(@direction: row) {
    -webkit-flex-direction: @direction;
    -ms-flex-direction: @direction;
    flex-direction: @direction;
}

.u-flex-wrap(@wrap: nowrap) {
    -webkit-flex-wrap: @wrap;
    -ms-flex-wrap: @wrap;
    flex-wrap: @wrap;
}

.u-flex-flow(@flow) {
    -webkit-flex-flow: @flow;
    -ms-flex-flow: @flow;
    flex-flow: @flow;
}

.u-flex-order(@order: 0) {
    -webkit-order: @order;
    -ms-order: @order;
    order: @order;
}

.u-flex-grow(@grow: 0) {
    -webkit-flex-grow: @grow;
    -ms-flex-grow: @grow;
    flex-grow: @grow;
}

.u-flex-shrink(@shrink: 1) {
    -webkit-flex-shrink: @shrink;
    -ms-flex-shrink: @shrink;
    flex-shrink: @shrink;
}

.u-flex-basis(@width: auto) {
    -webkit-flex-basis: @width;
    -ms-flex-basis: @width;
    flex-basis: @width;
}

.u-justify-content(@justify: flex-start) {
    -webkit-justify-content: @justify;
    -ms-justify-content: @justify;
    justify-content: @justify;
}

.u-align-content(@align: stretch) {
    -webkit-align-content: @align;
    -ms-align-content: @align;
    align-content: @align;
}

.u-align-items(@align: stretch) {
    -webkit-align-items: @align;
    -ms-align-items: @align;
    align-items: @align;
}

.u-align-self(@align: auto) {
    -webkit-align-self: @align;
    -ms-align-self: @align;
    align-self: @align;
}
